//+------------------------------------------------------------------+
//|                                                iMa_Check.mq4     |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_buffers 3
#property indicator_color1 Black
#property indicator_color2 Red
#property indicator_color3 Yellow
#property indicator_separate_window

extern int MA_Period = 13;
extern ENUM_MA_METHOD MA_Method = MODE_SMA;
extern ENUM_APPLIED_PRICE MA_Price  = PRICE_CLOSE; 

int MaMa_PerFast = 2;      
ENUM_MA_METHOD MaMa_Method = MODE_SMA;
int MaMa_PerSlow;

double MaBuff[],FastBuff[],SlowBuff[];


int init()
  {
  	MaMa_PerSlow = 2*MaMa_PerFast;
   IndicatorShortName("iMA-Check");
   IndicatorDigits(2);
   SetIndexBuffer(0,MaBuff);
   SetIndexBuffer(1,FastBuff);
   SetIndexBuffer(2,SlowBuff);
   
   SetIndexStyle(0,DRAW_NONE); 
   SetIndexStyle(1,DRAW_LINE,0,2);
   SetIndexStyle(2,DRAW_LINE,0,1);
   
   SetIndexLabel(0,"MA-Diff"); 
   SetIndexLabel(1,"MaMa Fast("+MaMa_PerFast+")"); 
   SetIndexLabel(2,"MaMa Slow("+MaMa_PerSlow+")"); 
 
   return(0);
}
  
int start()
  {
   int counted_bars=IndicatorCounted();
   int limit = Bars-counted_bars-1;
   for(int i=limit; i>=0; i--){
      MaBuff[i] = (iMA(NULL,0,MA_Period,0,MA_Method,MA_Price,i) - iMA(NULL,0,MA_Period*2,0,MA_Method,MA_Price,i))/Point; 
   }
   for (i=limit-1;i>=0;i--){
      FastBuff[i] = (iMAOnArray(MaBuff,0,MaMa_PerFast,0,MaMa_Method,i));
      SlowBuff[i] = (iMAOnArray(MaBuff,0,MaMa_PerSlow,0,MaMa_Method,i)); 
   }
   Comment("The bigger the candle-body the bigger the error! Comparison of sma(2) by iMaOnArray and self-calc.: (buff[i]+buff[i+1])/2",
   	"\nWatch the bar[0] - it is not updated!\nWait for some big candle bodies!\n"
   	"\nMaOnArr. 0: ",DoubleToStr(FastBuff[0],2)," =?= ",DoubleToStr((MaBuff[0]+MaBuff[1])/2,2)," = (",DoubleToStr(MaBuff[0],2)," + ",DoubleToStr(MaBuff[1],2)," )/ 2  Diff: ",DoubleToStr((MaBuff[0]+MaBuff[1])/2-FastBuff[0],2),
   	"\nMaOnArr. 1: ",DoubleToStr(FastBuff[1],2)," =?= ",DoubleToStr((MaBuff[1]+MaBuff[2])/2,2)," = (",DoubleToStr(MaBuff[1],2)," + ",DoubleToStr(MaBuff[2],2)," )/ 2  Diff: ",DoubleToStr((MaBuff[1]+MaBuff[2])/2-FastBuff[1],2),
   	"\nMaOnArr. 2: ",DoubleToStr(FastBuff[2],2)," =?= ",DoubleToStr((MaBuff[2]+MaBuff[3])/2,2)," = (",DoubleToStr(MaBuff[2],2)," + ",DoubleToStr(MaBuff[3],2)," )/ 2  Diff: ",DoubleToStr((MaBuff[2]+MaBuff[3])/2-FastBuff[2],2),
   	"\nMaOnArr. 3: ",DoubleToStr(FastBuff[3],2)," =?= ",DoubleToStr((MaBuff[3]+MaBuff[4])/2,2)," = (",DoubleToStr(MaBuff[3],2)," + ",DoubleToStr(MaBuff[4],2)," )/ 2  Diff: ",DoubleToStr((MaBuff[3]+MaBuff[4])/2-FastBuff[3],2),
   	"\nMaOnArr. 4: ",DoubleToStr(FastBuff[4],2)," =?= ",DoubleToStr((MaBuff[4]+MaBuff[5])/2,2)," = (",DoubleToStr(MaBuff[4],2)," + ",DoubleToStr(MaBuff[5],2)," )/ 2  Diff: ",DoubleToStr((MaBuff[4]+MaBuff[5])/2-FastBuff[4],2)
   );

//----
   return(0);
}
